Summary: TSS (TCG Software Stack) v1.2 access daemon for a TPM chip
Name: trousers
Version: 0.3.15
Release: 6%{?dist}
License: BSD
Url: http://trousers.sourceforge.net
Source0: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
Source1: tcsd.service

Patch0001: trousers-unlock-context_list-in-error-path.patch

BuildRequires: autoconf automake make libtool
BuildRequires: openssl-devel gettext-devel systemd
Requires(pre): shadow-utils
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
Requires: %{name}-lib = %{version}-%{release}

%description
TrouSerS is an open-source implementation of the Trusted Computing Group's
Software Stack (TSS) specification. Trousers aims to be compliant with the
1.1b and 1.2 TSS specifications available from the Trusted Computing
Group website: http://www.trustedcomputinggroup.org

You can use TrouSerS to write applications that make use of your TPM hardware.
TPM hardware can create, store and use RSA keys securely (without ever being
exposed in memory), verify a platform's software state using cryptographic
hashes and more.

The package needs the /dev/tpm device file to be present on your
system. It is a character device file major 10 minor 224, 0600 tss:tss.

%package lib
Summary: TrouSerS libtspi library

%description lib
The libtspi library for use in Trusted Computing enabled applications.

%package static
Summary: TrouSerS TCG Device Driver Library
Requires: %{name}-devel = %{version}-%{release}

%description static
The TCG Device Driver Library (TDDL) used by the TrouSerS tcsd as the
interface to the TPM's device driver.

%package devel
Summary: TrouSerS header files and documentation
Requires: %{name}-lib = %{version}-%{release}

%description devel
Header files and man pages for use in creating Trusted Computing enabled
applications.

%prep
%autosetup -p1
# fix man page paths
sed -i -e 's|/var/tpm|/var/lib/tpm|g' -e 's|/usr/local/var|/var|g' man/man5/tcsd.conf.5.in man/man8/tcsd.8.in

%build
sh ./bootstrap.sh
%configure --with-gui=openssl
%make_build

%install
mkdir -p %{buildroot}%{_localstatedir}/lib/tpm
%make_install
find %{buildroot} -type f -name '*.la' -print -delete
mkdir -p %{buildroot}%{_unitdir}
install -Dpm0644 %{SOURCE1} %{buildroot}%{_unitdir}/

%pre
getent group tss >/dev/null || groupadd -f -g 59 -r tss
if ! getent passwd tss >/dev/null ; then
    if ! getent passwd 59 >/dev/null ; then
      useradd -r -u 59 -g tss -d /dev/null -s /sbin/nologin -c "Account used for TPM access" tss
    else
      useradd -r -g tss -d /dev/null -s /sbin/nologin -c "Account used for TPM access" tss
    fi
fi
exit 0

%post
%systemd_post tcsd.service

%preun
%systemd_preun tcsd.service

%postun
%systemd_postun_with_restart tcsd.service 

%files
%license LICENSE
%doc README ChangeLog AUTHORS
%config(noreplace) %attr(0640, root, tss) %{_sysconfdir}/tcsd.conf
%attr(644,root,root) %{_unitdir}/tcsd.service
%attr(0700, tss, tss) %{_localstatedir}/lib/tpm/
%{_sbindir}/tcsd
%{_mandir}/man5/*
%{_mandir}/man8/*

%files lib
%{_libdir}/libtspi.so.1*

%files static
%{_libdir}/libtddl.a

%files devel
%doc doc/LTC-TSS_LLD_08_r2.pdf doc/TSS_programming_SNAFUs.txt
%attr(0755, root, root) %{_libdir}/libtspi.so
%{_includedir}/tss/
%{_includedir}/trousers/
%{_mandir}/man3/Tspi_*

%changelog
* Thu Sep 26 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.3.15-6
- Rebuilt for clarifying the packages requirement in BaseOS and AppStream

* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.3.15-5
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.3.15-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.3.15-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.3.15-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Jun 29 2022 Anakin Zhang <anakinzhang@tencent.com> - 0.3.15-1
- Initial build
